<template>
  <div class="p-sm-2">
    <div class="my-3 pb-2">
      <div class="d-flex justify-content-between align-items-center">
        <h1>settings</h1>
      </div>
    </div>

    <div class="settings-card-columns">
      <card-widget header="Account" class="card-app-list">
        <div class="pt-2">
          <div class="d-flex w-100 justify-content-between px-3 px-lg-4 mb-4">
            <div>
              <span class="d-block">Secret words</span>
              <small class="d-block" style="opacity: 0.4"
                >Note down your 24 secret words</small
              >
            </div>

            <b-button
              variant="outline-primary"
              size="sm"
              @click="showSeedModal = true"
              >View</b-button
            >

            <b-modal
              id="seed-modal"
              v-model="showSeedModal"
              centered
              hide-footer
            >
              <template #modal-header>
                <div
                  class="px-2 px-sm-3 pt-2 d-flex justify-content-between w-100"
                >
                  <h3>secret words</h3>
                  <!-- Emulate built in modal header close button action -->
                  <a
                    href="#"
                    class="align-self-center"
                    @click.stop.prevent="showSeedModal = true"
                  >
                    <svg
                      width="18"
                      height="18"
                      viewBox="0 0 18 18"
                      fill="none"
                      xmlns="http://www.w3.org/2000/svg"
                    >
                      <path
                        fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M13.6003 4.44197C13.3562 4.19789 12.9605 4.19789 12.7164 4.44197L9.02116 8.1372L5.32596 4.442C5.08188 4.19792 4.68615 4.19792 4.44207 4.442C4.198 4.68607 4.198 5.0818 4.44207 5.32588L8.13728 9.02109L4.44185 12.7165C4.19777 12.9606 4.19777 13.3563 4.44185 13.6004C4.68592 13.8445 5.08165 13.8445 5.32573 13.6004L9.02116 9.90497L12.7166 13.6004C12.9607 13.8445 13.3564 13.8445 13.6005 13.6004C13.8446 13.3563 13.8446 12.9606 13.6005 12.7165L9.90505 9.02109L13.6003 5.32585C13.8444 5.08178 13.8444 4.68605 13.6003 4.44197Z"
                        fill="#6c757d"
                      />
                    </svg>
                  </a>
                </div>
              </template>
              <reveal-seed />
            </b-modal>
          </div>
        </div>
        <div class="pt-0">
          <div class="d-flex w-100 justify-content-between px-3 px-lg-4 mb-4">
            <div>
              <span class="d-block">Password</span>
              <small class="d-block" style="opacity: 0.4"
                >Change your Citadel's password</small
              >
            </div>

            <b-button
              variant="outline-primary"
              size="sm"
              :disabled="isChangingPassword"
              @click="showChangePasswordModal = true"
              >Change</b-button
            >

            <b-modal v-model="showChangePasswordModal" centered hide-footer>
              <template #modal-header>
                <div
                  class="px-2 px-sm-3 pt-2 d-flex justify-content-between w-100"
                >
                  <h3>change password</h3>
                  <!-- Emulate built in modal header close button action -->
                  <a
                    href="#"
                    class="align-self-center"
                    @click.stop.prevent="showChangePasswordModal = false"
                  >
                    <svg
                      width="18"
                      height="18"
                      viewBox="0 0 18 18"
                      fill="none"
                      xmlns="http://www.w3.org/2000/svg"
                    >
                      <path
                        fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M13.6003 4.44197C13.3562 4.19789 12.9605 4.19789 12.7164 4.44197L9.02116 8.1372L5.32596 4.442C5.08188 4.19792 4.68615 4.19792 4.44207 4.442C4.198 4.68607 4.198 5.0818 4.44207 5.32588L8.13728 9.02109L4.44185 12.7165C4.19777 12.9606 4.19777 13.3563 4.44185 13.6004C4.68592 13.8445 5.08165 13.8445 5.32573 13.6004L9.02116 9.90497L12.7166 13.6004C12.9607 13.8445 13.3564 13.8445 13.6005 13.6004C13.8446 13.3563 13.8446 12.9606 13.6005 12.7165L9.90505 9.02109L13.6003 5.32585C13.8444 5.08178 13.8444 4.68605 13.6003 4.44197Z"
                        fill="#6c757d"
                      />
                    </svg>
                  </a>
                </div>
              </template>
              <div class="px-4 pb-2">
                <label class="visually-hidden" for="input-current-password"
                  >Current password</label
                >
                <input-password
                  id="input-current-password"
                  ref="password"
                  v-model="currentPassword"
                  placeholder="current password"
                  input-group-class="neu-input-group"
                  :input-class="[
                    isIncorrectPassword ? 'incorrect-password' : '',
                    'form-control form-control-lg neu-input w-100',
                  ]"
                  :disabled="isChangingPassword"
                />
                <div class="py-2"></div>
                <label class="visually-hidden" for="input-new-passwor"
                  >New password</label
                >
                <input-password
                  id="input-new-password"
                  ref="password"
                  v-model="newPassword"
                  placeholder="new password"
                  input-group-class="neu-input-group"
                  input-class="form-control form-control-lg neu-input w-100"
                  :disabled="isChangingPassword"
                />
                <div class="py-2"></div>
                <label class="visually-hidden" for="input-confirm-new-password"
                  >Confirm new password</label
                >
                <input-password
                  id="input-confirm-new-password"
                  ref="password"
                  v-model="confirmNewPassword"
                  placeholder="confirm password"
                  input-group-class="neu-input-group"
                  input-class="form-control form-control-lg neu-input w-100"
                  :disabled="isChangingPassword"
                />

                <div v-if="userStore.totpEnabled">
                  <input-otp-token
                    :disabled="isChangingPassword"
                    :success="isCorrectTotp"
                    :error="isIncorrectTotp"
                    @otp-token="setTotpToken"
                    @keyup="hideOtpError"
                  />
                </div>
                <div class="py-2"></div>
                <b-alert variant="warning" show>
                  <small>
                    ⚠ Remember, there is no "Forgot Password" button. If you
                    lose your password, you will have to recover your Citadel
                    using your 24 secret words and channel backup.
                  </small>
                </b-alert>

                <div v-show="isIncorrectPassword" class="my-2 text-center">
                  <small class="text-danger error">Incorrect password</small>
                </div>

                <div v-show="isIncorrectTotp" class="my-2 text-center">
                  <small class="text-danger error">Incorrect code</small>
                </div>

                <b-button
                  class="w-100"
                  variant="success"
                  size="lg"
                  :disabled="isChangingPassword || !isAllowedToChangePassword"
                  @click="changePassword"
                  >{{
                    isChangingPassword
                      ? "Changing password..."
                      : "Change password"
                  }}</b-button
                >
              </div>
            </b-modal>
          </div>
        </div>
        <div class="pt-0">
          <div class="d-flex w-100 justify-content-between px-3 px-lg-4 mb-4">
            <div>
              <span class="d-block">Two-factor authentication</span>
              <small class="d-block" style="opacity: 0.4"
                >Manage enhanced security measure</small
              >
            </div>

            <b-button
              variant="outline-primary"
              size="sm"
              :disabled="isEnablingTwoFactorAuth"
              @click="openTwoFactorAuthModal"
            >
              <span v-if="!userStore.totpEnabled">Enable</span>
              <span v-else>Disable</span>
            </b-button>

            <b-modal
              id="two-factor-auth-modal"
              v-model="showTotpModal"
              centered
              hide-footer
            >
              <template #modal-header="{ close }">
                <div
                  class="px-2 px-sm-3 pt-2 d-flex justify-content-between w-100"
                >
                  <h3>Two-factor authentication</h3>

                  <!-- Emulate built in modal header close button action -->
                  <a
                    href="#"
                    class="align-self-center"
                    @click.stop.prevent="close"
                  >
                    <svg
                      width="18"
                      height="18"
                      viewBox="0 0 18 18"
                      fill="none"
                      xmlns="http://www.w3.org/2000/svg"
                    >
                      <path
                        fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M13.6003 4.44197C13.3562 4.19789 12.9605 4.19789 12.7164 4.44197L9.02116 8.1372L5.32596 4.442C5.08188 4.19792 4.68615 4.19792 4.44207 4.442C4.198 4.68607 4.198 5.0818 4.44207 5.32588L8.13728 9.02109L4.44185 12.7165C4.19777 12.9606 4.19777 13.3563 4.44185 13.6004C4.68592 13.8445 5.08165 13.8445 5.32573 13.6004L9.02116 9.90497L12.7166 13.6004C12.9607 13.8445 13.3564 13.8445 13.6005 13.6004C13.8446 13.3563 13.8446 12.9606 13.6005 12.7165L9.90505 9.02109L13.6003 5.32585C13.8444 5.08178 13.8444 4.68605 13.6003 4.44197Z"
                        fill="#6c757d"
                      />
                    </svg>
                  </a>
                </div>
              </template>
              <div class="px-4 pb-2">
                <div v-if="!userStore.totpEnabled">
                  <p>
                    Scan the code below with your authenticator app or copy the
                    code.
                  </p>
                  <qr-code
                    class="mb-3 mx-auto"
                    :value="authenticatorSecretUri"
                    :size="190"
                    level="M"
                    show-logo
                  ></qr-code>
                  <input-copy
                    class="w-100 mx-auto"
                    size="sm"
                    :value="userStore.totpKey"
                  ></input-copy>

                  <br />
                </div>
                <label class="visually-hidden" for="input-token">
                  Enter the code from your authenticator app to verify and
                  {{ userStore.totpEnabled ? "disable" : "enable" }} 2FA.
                </label>
                <b-form-input
                  id="input-token"
                  v-model="authenticatorToken"
                  class="mb-4 neu-input"
                  size="lg"
                  placeholder="6-digit-code"
                ></b-form-input>
                <b-button
                  v-if="!userStore.totpEnabled"
                  class="w-100"
                  variant="success"
                  size="lg"
                  :disabled="
                    isEnablingTwoFactorAuth || !isAllowedToChangeTwoFactorAuth
                  "
                  @click="enableTwoFactorAuth"
                  >{{
                    isEnablingTwoFactorAuth ? "Enabling 2FA..." : "Enable 2FA"
                  }}</b-button
                >

                <b-button
                  v-if="userStore.totpEnabled"
                  class="w-100"
                  variant="danger"
                  size="lg"
                  :disabled="
                    isDisablingTwoFactorAuth || !isAllowedToChangeTwoFactorAuth
                  "
                  @click="disableTwoFactorAuth"
                  >{{
                    isDisablingTwoFactorAuth
                      ? "Disabling 2FA..."
                      : "Disable 2FA"
                  }}</b-button
                >
              </div>
            </b-modal>
          </div>
        </div>
        <div class="px-3 px-lg-4 py-1"></div>
      </card-widget>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

import CardWidget from "@/components/CardWidget.vue";
import RevealSeed from "@/components/RevealSeed.vue";
import InputPassword from "@/components/Utility/InputPassword.vue";
import InputCopy from "@/components/Utility/InputCopy.vue";
import InputOtpToken from "@/components/Utility/InputOtpToken.vue";
import QrCode from "@/components/Utility/QrCode.vue";
import useSdkStore from "@/store/sdk";
import useSystemStore from "@/store/system";
import useUserStore from "@/store/user";
import useToast from "@/utils/toast";

export default defineComponent({
  components: {
    CardWidget,
    InputPassword,
    InputCopy,
    InputOtpToken,
    RevealSeed,
    QrCode,
  },
  setup() {
    const sdkStore = useSdkStore();
    const systemStore = useSystemStore();
    const userStore = useUserStore();
    const toast = useToast();
    return { sdkStore, systemStore, userStore, toast };
  },
  data() {
    return {
      currentPassword: "",
      isIncorrectPassword: false,
      isCorrectTotp: false,
      isIncorrectTotp: false,
      newPassword: "",
      confirmNewPassword: "",
      totpToken: "",
      isChangingPassword: false,
      isEnablingTwoFactorAuth: false,
      isDisablingTwoFactorAuth: false,
      showChangePasswordModal: false,
      showSeedModal: false,
      showTotpModal: false,
      authenticatorToken: "",
    } as {
      currentPassword: string;
      isIncorrectPassword: boolean;
      isCorrectTotp: boolean;
      isIncorrectTotp: boolean;
      newPassword: string;
      confirmNewPassword: string;
      totpToken: string;
      isChangingPassword: boolean;
      isEnablingTwoFactorAuth: boolean;
      isDisablingTwoFactorAuth: boolean;
      authenticatorToken: string;
      showChangePasswordModal: boolean;
      showSeedModal: boolean;
      showTotpModal: boolean;
    };
  },
  computed: {
    authenticatorSecretUri(): string {
      return `otpauth://totp/${encodeURIComponent(
        this.userStore.name,
      )}?secret=${this.userStore.totpKey}&period=30&issuer=Citadel`;
    },
    isAllowedToChangeTwoFactorAuth(): boolean {
      return this.authenticatorToken.length >= 6;
    },
    isAllowedToChangePassword(): boolean {
      if (!this.currentPassword) {
        return false;
      }
      if (this.newPassword.length < 12) {
        return false;
      }
      if (this.newPassword !== this.confirmNewPassword) {
        return false;
      }
      if (this.currentPassword === this.newPassword) {
        return false;
      }
      return true;
    },
  },
  watch: {
    currentPassword: function () {
      this.isIncorrectPassword = false;
    },
  },
  created() {
    this.userStore.getTotpEnabledStatus();
  },
  methods: {
    setTotpToken(totpToken: string) {
      this.totpToken = totpToken;
    },
    async enableTwoFactorAuth() {
      this.isEnablingTwoFactorAuth = true;

      try {
        await this.sdkStore.citadel.auth.enableTotp(this.authenticatorToken);

        this.toast.success(
          "2FA enabled",
          "You've successfully enabled two-factor authentication",
        );

        this.showTotpModal = false;

        // set optimistic
        this.userStore.totpEnabled = true;
        // wait for file to be finished writing
        await delay(500);
        // update with real status
        this.userStore.getTotpEnabledStatus();

        this.isEnablingTwoFactorAuth = false;
        this.authenticatorToken = "";
      } catch (error) {
        if (error && (error as Error).message) {
          this.toast.error("Error", (error as Error).message);
        }
        this.isEnablingTwoFactorAuth = false;
      }
    },
    async disableTwoFactorAuth() {
      this.isDisablingTwoFactorAuth = true;

      try {
        await this.sdkStore.citadel.auth.disableTotp(this.authenticatorToken);

        this.toast.success(
          "2FA disabled",
          "You've successfully disabled two-factor authentication",
        );

        this.showTotpModal = false;

        // set optimistic
        this.userStore.totpEnabled = false;
        // wait for file to be finished writing
        await delay(500);
        // update with real status
        this.userStore.getTotpEnabledStatus();

        this.isDisablingTwoFactorAuth = false;
        this.authenticatorToken = "";
      } catch (error) {
        if (error && (error as Error).message) {
          this.toast.error("Error", (error as Error).message);
        }
        this.isDisablingTwoFactorAuth = false;
      }
    },
    async changePassword() {
      this.isChangingPassword = true;
      this.isIncorrectPassword = false;
      this.isIncorrectTotp = false;

      try {
        await this.sdkStore.citadel.auth.changePassword(
          this.currentPassword,
          this.newPassword,
          this.totpToken,
        );

        this.toast.success(
          "Password Changed",
          "You've successfully changed your Citadel's password",
        );
      } catch (error) {
        console.error(error);
        const errorString = String(error);
        const isIncorrectPassword = errorString.includes("Incorrect password");
        const isIncorrectTotp = errorString.includes("Incorrect 2FA code");

        this.isIncorrectPassword = isIncorrectPassword;
        this.isIncorrectTotp = isIncorrectTotp;

        this.isChangingPassword = false;
        return;
      }

      this.isChangingPassword = false;
      this.showChangePasswordModal = false;

      // Remove passwords from view
      this.currentPassword = "";
      this.newPassword = "";
      this.confirmNewPassword = "";
      this.totpToken = "";
    },
    async openTwoFactorAuthModal() {
      await this.userStore.getTotpKey();
      this.showTotpModal = true;
    },
    async reboot() {
      if (!this.systemStore.hasRebooted) {
        try {
          await this.systemStore.reboot();
        } catch (error) {
          console.error(error);
          this.toast.error(
            "Reboot failed",
            "Something went wrong and Citadel was not able to reboot",
          );
        }
      }
    },
  },
});
definePageMeta({
  layout: "authenticated",
  pageTransition: { name: "change-page", mode: "out-in" },
});
</script>
